#include <stdio.h>

#include <hash_set.h>



struct  eqstr
{
   bool                 operator () ( const char *  s1, const char *  s2 ) const
   {
      return ( strcmp ( s1, s2 ) == 0 );
   }
};



void  lookup ( const hash_multiset < const char *, hash < const char * >, eqstr > &  Set, const char *  word )
{
   int   n_found = Set.count ( word );

   cout << word << ": " << n_found << " " << ( n_found == 1 ? "instance" : "instances" ) << endl;
}



int  main ()
{
   hash_multiset < const char *, hash < const char * >, eqstr >      Set;

   Set.insert ( "mango"  );
   Set.insert ( "kiwi"   );
   Set.insert ( "apple"  );
   Set.insert ( "kiwi"   );
   Set.insert ( "mango"  );
   Set.insert ( "mango"  );
   Set.insert ( "apricot");
   Set.insert ( "banana" );
   Set.insert ( "mango"  );

   lookup ( Set, "mango"  );
   lookup ( Set, "apple"  );
   lookup ( Set, "durian" );

   return (  0 );
}